(* EPITA SPE 2013/2014        *)
(* Controle 1 - Novembre 2013 *)
(* question01                 *)

module Q = Question01


let main () =
  begin
    let q = new Test_frame.qSeedSizeInt 1 20 in
    q#beginParse;
    q#init;
    Format.printf "@[<v 2>Fixed values:";
    Format.printf "@,fact 0 = %d   (should be 1)" (Q.fact 0);
    Format.printf "@,fact 1 = %d   (should be 1)" (Q.fact 1);
    Format.printf "@,fact 5 = %d (should be 120)" (Q.fact 5);
    Format.printf "@]@,@[<v 2>Random tests:";
    for i = 1 to q#getSize do
	    let n = q#getN in
      Format.printf "@,fact %d\t= %d" n (Q.fact n);
    done;
    begin
      try let n = - (q#getN + 1) in Format.printf "@,fact %d = %d" n (Q.fact n)
      with
        | Q.Neg_param i -> Format.printf "@,fact (%d)\t= Neg_param (%d)" i i
        | _ -> Format.printf "@,Wrong exception !"
    end;
    Format.printf "@]@.";
    exit 0;
  end

let _ = main ()
